package io.gitlab.jfronny.inceptum.common;

import io.gitlab.jfronny.commons.io.JFiles;
import io.gitlab.jfronny.inceptum.common.model.inceptum.Config;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.HashMap;

public class ConfigHolder {
    public static Config CONFIG;

    public static void load() throws IOException {
        if (!Files.exists(MetaHolder.CONFIG_PATH.getParent()))
            Files.createDirectories(MetaHolder.CONFIG_PATH.getParent());
        if (!Files.exists(MetaHolder.CONFIG_PATH)) {
            Path gLaunch2 = MetaHolder.BASE_PATH.resolve("glaunch2.json");
            if (Files.exists(gLaunch2)) {
                Files.move(gLaunch2, MetaHolder.CONFIG_PATH);
            } else {
                JFiles.writeObject(MetaHolder.CONFIG_PATH, new Config());
            }
        }
        CONFIG = JFiles.readObject(MetaHolder.CONFIG_PATH, Config.class);
    }

    public static void saveConfig() {
        try {
            JFiles.writeObject(MetaHolder.CONFIG_PATH, CONFIG);
        } catch (IOException e) {
            Utils.LOGGER.error("Could not save config", e);
        }
    }
}
