package io.gitlab.jfronny.inceptum.launcher.util.ignore;

import java.util.function.Function;
import java.util.regex.MatchResult;
import java.util.regex.Pattern;

public class Replacer {
    private final String name;
    private final Pattern regex;
    private final Function<MatchResult, String> matchEvaluator;

    public Replacer(String name, String regex, Function<MatchResult, String> matchEvaluator) {
        this.name = name;
        this.regex = Pattern.compile(regex);
        this.matchEvaluator = matchEvaluator;
    }

    public String invoke(String pattern) {
        return regex.matcher(pattern).replaceAll(matchEvaluator);
    }

    @Override
    public String toString() {
        return name;
    }
}
