package io.gitlab.jfronny.inceptum;

import java.io.File;
import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.net.URISyntaxException;
import java.nio.file.Path;
import java.util.Set;

public class WrapperStrap {
    public static final ClassLoader SYSTEM_LOADER = ClassLoader.getSystemClassLoader();

    public static void main(String[] args) throws ClassNotFoundException, NoSuchMethodException, InvocationTargetException, IllegalAccessException, IOException, URISyntaxException {
        System.out.println("Starting Inceptum Wrapper ClassLoader");
        bootstrap(Set.of(new File(WrapperStrap.class.getProtectionDomain().getCodeSource().getLocation().toURI()).toPath()),
                "io.gitlab.jfronny.inceptum.Wrapper",
                args);
    }

    public static void bootstrap(Iterable<Path> jars, String mainClass, String[] args) throws ClassNotFoundException, NoSuchMethodException, InvocationTargetException, IllegalAccessException, IOException, URISyntaxException {
        try (WrapperClassLoader loader = new WrapperClassLoader(jars, SYSTEM_LOADER)) {
            Thread.currentThread().setContextClassLoader(loader);
            wrapperInit(loader);
            loader.loadClass(mainClass)
                    .getDeclaredMethod("main", String[].class)
                    .invoke(null, new Object[]{args});
        }
    }

    private static void wrapperInit(ClassLoader loader) {
        try {
            loader.loadClass("io.gitlab.jfronny.inceptum.common.Utils")
                    .getMethod("wrapperInit", ClassLoader.class)
                    .invoke(null, SYSTEM_LOADER);
        } catch (Throwable e) {
            System.out.println("Could not perform wrapper init, utils class probably moved");
            e.printStackTrace();
        }
    }
}
